uniform float Phase;
uniform float FogDensity;

varying float Density;

varying float Fog;

uniform float Frequency;
const float Amplitude = 1.;


#define Displacemt(wavePos) sin((wavePos) * Frequency) * Amplitude + \
                            Amplitude + \
                            (wavePos) * 0.0000000000001

void main()
{
	float waveX = gl_Vertex.x + Phase;
	float waveY = gl_Vertex.y + Phase * 0.8;
	float waveZ = gl_Vertex.z + Phase * 1.3;
	
	float dmtX = Displacemt(waveX);
	float dmtY = Displacemt(waveY);
	float dmtZ = Displacemt(waveZ);
	
	float dmt = (dmtX + dmtY + dmtZ) / 3.;
	
//	if(dmt < 0.)
//		dmt = 0.;
		
	gl_Vertex.x *= dmt;
	gl_Vertex.y *= dmt;
	gl_Vertex.z *= dmt;
	
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	Density = 0.2 - dmt * 0.3 * dmtX * dmtY * dmtZ;
	
	Fog = 1.; // fog deactivated for coreography
	
}
