vec4 pointLight(vec3 objectPos, vec3 objectNormal, vec3 lightPos)
{
	vec3 eyeDirLightPos = lightPos - objectPos;
	vec3 lightDir = normalize(eyeDirLightPos);
	float lightDistance = length(eyeDirLightPos);
	
	if(lightDistance > 3.) return vec4(0., 0., 0., 1.);
	
	//vec3 halfVector = normalize(gl_LightSource[0].halfVector.xyz);
	float nDotL = max(dot(objectNormal, lightDir), 0.);
	
	if(nDotL > 0.)
	{
		float att = 1. / (
				gl_LightSource[0].constantAttenuation +
				gl_LightSource[0].linearAttenuation * lightDistance +
				gl_LightSource[0].quadraticAttenuation * lightDistance *
						lightDistance
		);
		return att * (
				gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * nDotL +
				gl_FrontMaterial.diffuse * gl_LightSource[0].ambient
		);
	}
	
	return vec4(0., 0., 0., 1.);
}

float fogFactor(float density)
{
	float fog = 1. - gl_Position.z * density;
	if(fog > 1.)
	{
		fog = 1.;
	}
	else
	{
		if(fog < 0.)
			fog = 0.;
	}
	return fog;
}

float fogFactor(float density, float begin)
{
	float z = gl_Position.z - begin;
	if(z < 0.) return 1.;
	float fog = 1. - z * density;
	if(fog > 1.)
	{
		fog = 1.;
	}
	else
	{
		if(fog < 0.)
			fog = 0.;
	}
	return fog;
}
