varying vec4 Coord;
varying vec3 Pos;
varying vec3 Normal;

uniform sampler2D Texture;

uniform sampler2DShadow ShadowMap;
varying vec4 ShadowCoord;

varying float Fog;

vec4 pointLight(vec3 objectPos, vec3 objectNormal, vec3 lightPos);

void main()
{
	Coord.xy += 2.;
	Coord.xy /= 4.;
	vec3 c = vec3(texture2D(Texture, Coord.xy));
	
	vec3 light = pointLight(Pos, Normal, gl_LightSource[0].position.xyz).rgb;
	
	float x = ShadowCoord.x;
	float y = ShadowCoord.y;
	if((x >= 0.) && (x <= 1.) && (y >= 0.) && (y <= 1.))
		light *= shadow2DProj(ShadowMap, ShadowCoord).x;
		
	gl_FragColor = vec4(Fog*c * (0.2 + light*0.8), 1.);
	//gl_FragColor = vec4(c * light, 1.);
	
}
