varying vec4 Coord;
varying vec3 Pos;
varying vec3 Normal;

// shadow map
const mat4 ProjTexMatrix = mat4(
		0.5, 0  , 0  , 0  ,
		0  , 0.5, 0  , 0  ,
		0  , 0  , 0.5, 0  ,
		0.5, 0.5, 0.5, 1  );
uniform mat4 LightLookAtMatrix;
uniform mat4 EyeLookAtMatrix;
varying vec4 ShadowCoord;

uniform float FogDensity;
varying float Fog;

float fogFactor(float density);

void main()
{
	
	vec3 normal = normalize(mat3(EyeLookAtMatrix) * gl_NormalMatrix * gl_Normal);
	Normal = normal;	
	Pos = vec3(EyeLookAtMatrix * gl_ModelViewMatrix * gl_Vertex);
	
	Coord = gl_Vertex;
	
	mat4 mvpMatrix = gl_ProjectionMatrix * EyeLookAtMatrix *
			gl_ModelViewMatrix;
	gl_Position = mvpMatrix * gl_Vertex;

	// shadowmap coordinate
	vec4 view = LightLookAtMatrix * gl_ModelViewMatrix * gl_Vertex;
	//view.z += 0.02;
	view = gl_ProjectionMatrix * view;
	view.x /=  5.;
	view.y /=  2.;
	ShadowCoord = ProjTexMatrix * view;
	
	Fog = fogFactor(FogDensity);
	
}
