uniform sampler2D Texture;

uniform float OhFactor; // max 2.

varying vec3 Coord;

void main()
{
	vec4 c = gl_Color;
	
	vec3 v = Coord;
	
	float vx = v.x;
	float vz = v.z;
	float deformFactor = 0.5;
	
	if(v.z < 0.)
		OhFactor /= 1. + 1.6*sqrt(-v.z)*-v.z*(OhFactor-1.);
	
	vx *= OhFactor;
	vz /= OhFactor;
	vz -= (1. - OhFactor) * 0.1;
	deformFactor = (2. - OhFactor) * 0.5;
	
	// singer's mouth
	float x =  (vx + 1.) / 2.;
	float z = (vz + 1.) / 2.;
	float deform = vx * deformFactor;
	
	float r = 1.; // radius
	if(v.y > 0.4)
	{
		//if(v.x < 0.) // schaut aus wie da haider :-D
		r *= 1.- texture2D(Texture, vec2(x, z + deform*deform)).r * 0.1;
	}
	
	r = (r - 0.9) * 10.;
	
	//c *= texture2D(Texture, gl_TexCoord[0].st);
	//gl_FragColor = c * r;
	gl_FragColor = vec4(c.rgb, 1.-r);
	//gl_FragColor = vec4(1., 0., 0., 1.);
}
