uniform float Phase;
uniform float FogDensity;

varying float Density;

varying float Fog;

uniform float Frequency;
const float Amplitude = 1.;


#define Displacemt(wavePos) sin((wavePos) * Frequency) * Amplitude + \
                            Amplitude + \
                            (wavePos) * 0.0000000000001

void main()
{
	Density = 0.5;
	
	float x = gl_Vertex.x;
	float y = gl_Vertex.y;
	float z = gl_Vertex.z + 1.;
	
	gl_Vertex.x *= (2.-z) * 0.3 + 0.03 * sin(-Phase * Frequency * 1.3 + z*10.);
	gl_Vertex.y *= (2.-z) * 0.3 + 0.03 * sin(-Phase * Frequency * 1.7 + z*10.);
	gl_Vertex.z = z * (1. + (1.+sin(Phase * Frequency)) * 0.03);
	
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	
	/*float px = gl_Position.x;
	float py = gl_Position.y;*/
	float a = z - 0.3;
	Density /= 1. + /*50.*(px*px+py*py) +*/ 10.*a*a;
	
	Fog = 1. - gl_Position.z * FogDensity;
	if(Fog > 1.)
	{
		Fog = 1.;
	}
	else
	{
		if(Fog < 0.)
			Fog = 0.;
	}
	Fog = Fog*-0.000000000001 + 1.; // fog deactivated for choreography
	
}
