varying vec3 Coord;
varying vec3 ReflectDir;

vec4 pointLight(vec3 objectPos, vec3 objectNormal, vec3 lightPos);

void main()
{
	vec3 pos, normal, lightDir;
	vec4 diffuse;
	float nDotL;
	
	pos = vec3(gl_ModelViewMatrix * gl_Vertex);
	normal = normalize(gl_NormalMatrix * gl_Normal);
	lightDir = normalize(vec3(gl_LightSource[0].position) - pos);
	nDotL = max(dot(normal, lightDir), 0.);
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse;
	
	//gl_FrontColor = nDotL * diffuse;
	vec3 color = vec3(0.7, 0.7, 0.7);
	color += pointLight(pos, normal, gl_LightSource[0].position.xyz).rgb;
	gl_FrontColor = vec4(color, 1.);
	
	gl_Position = ftransform();
	
	Coord = vec3(gl_Vertex);
	
	ReflectDir = normalize(vec3(gl_Vertex));
	
}
